<template lang="pug">
    div
        .posts(v-if="articles.length > 0")
            ArticleBox(v-for="article in articles" :article="article")
        .clearfix.center-button
            center
                a(@click="loadMore()" v-if="isVisible").btn.btn-primary Load more

</template>

<script lang="ts">
    import Vue from "vue";
    import Vuex from 'vuex';
    import PostsService from '../../services/PostsService';
    import ArticleBox from '../components/ArticleBox.vue';

    const DEFAULT_POSTS_LIMIT = 12;

    export default Vue.extend({

        components: {
            ArticleBox
        },
        data() {
            return {
                inProgress: false,
                isVisible: true,
                articles: [],
                skip: DEFAULT_POSTS_LIMIT
            }
        },

        computed: {
            blogId() {
                return document.getElementById('blogId')['value'];
            },
            categoryId() {
                const categoryIndicator = document.getElementById('categoryId');
                return categoryIndicator ? categoryIndicator['value'] : null;
            }
        },

        methods: {
            loadMore () {
                console.log('Testing load more', this.skip, this.blogId, this.categoryId);
                PostsService.loadMore(this.blogId, this.categoryId, this.skip)
                    .then((response: any) => {
                        const {data} = response;
                        console.log(data.posts);
                        this.articles.push(...data.posts);
                        this.skip += data.posts.length;
                        this.isVisible = data.posts.length === DEFAULT_POSTS_LIMIT;
                    })
            }
        }

    });
</script>
